/*
 * generate a binary from a portable (ASCII) form of a .MAP file
 */
 
#include <stdio.h>
#include <fcntl.h>

typedef struct coord
{
	float lat;	/* latitude */
	float lon;	/* longitude */
	int fnew;	/* 0=draw line, 1=just move pen, -1=EOF */
} coord;

main(argc, argv)
int argc;
char **argv;
{
coord cd;
int f;
FILE *g;
char name[30];
int i;
float num;

	if (argc != 2)
	{
		printf("usage: genport filename\n");
		exit(1);
	}
	
	strcpy(name, argv[1]);
	strcat(name, ".MAP");
	f = creat(name, 0666);
	if (f < 0)
	{
		perror(name);
		exit(1);
	}
	
	strcpy(name, argv[1]);
	strcat(name, ".ASC");
	g = fopen(name, "r");
	if (g==NULL)
	{
		perror(name);
		exit(1);
	}
	
	for (i=0; i < 4; i++)
	{
		fscanf(g, "%f\n", &num);
		write(f, &num, sizeof(num));
	}

	while (fscanf(g, "%f %f %d\n", &cd.lat, &cd.lon, &cd.fnew) > 0)
	{
		write(f, &cd, sizeof(cd));
	}

	fclose(g);
	close(f);
	exit(0);
}
