/*
 * portable plotting interface for Sun CGI
 * By E. Roskos 11/8/88
 */

#include <cgidefs.h>
#include <stdio.h>

#define XMAX 720
#define YMAX 720

Cvwsurf dev;
Cint devname;

static int cx, cy;

graphics()
{
Ccoor botleft, topright;

	if (open_cgi()) perror("open_cgi");
	NORMAL_VWSURF(dev, PIXWINDD);
	if (open_vws(&devname, &dev)) perror("open_vws");
	if (activate_vws(devname)) perror("activate_vws");
	botleft.x = 0;
	botleft.y = 0;
	topright.x = XMAX;
	topright.y = YMAX;
	if (vdc_extent(&botleft, &topright)) perror("vdc_extent");
}

text()
{
	if (deactivate_vws(devname)) perror("deactivate_vws");
	if (close_vws(devname)) perror("close_vws");
	if (close_cgi()) perror("close_cgi");
}

erasegraph()
{
	clear_view_surface(devname, 7, ON);
}

moveto(x, y)
int x, y;
{
	cx = x;
	cy = y;
}

lineto(x, y)
int x, y;
{
Ccoor list[2];
Ccoorlist ccl;

	list[0].x = cx;
	list[0].y = YMAX - cy;
	list[1].x = x;
	list[1].y = YMAX - y;
	ccl.ptlist = list;
	ccl.n = 2;
	if (polyline(&ccl)) perror("polyline");
	cx = x;
	cy = y;
}

int
getx()
{
	return(cx);
}

int 
gety()
{
	return(cy);
}

dotline(n)
int n;
{
int rc = 0;

	switch (n)
	{
	case 0:
		rc=line_type(SOLID);
		break;
		
	case 1:
		rc=line_type(DOTTED);
		break;
		
	case 2:
		rc=line_type(DASHED);
		break;
		
	default:
		fprintf(stderr, "\007icgi dotline: bad dot value %d\n", n);
		break;
	}

	if (rc)
	{
		fprintf(stderr, "\007icgi dotline: line_type returned error %d\n",
			rc);
	}
}

color(n)
int n;
{
int rc;
	rc = line_color(n);
	if (rc)
	{
		fprintf(stderr, "\007icgi color: line_color returned error %d\n",
			rc);
	}
}
